module Stupeflixclient
  class Main
    attr_accessor :client, :username, :meta, :notify, :profile_names, :uploads
    def initialize username='test'
      @username = username
      @notify = nil
      @meta = nil
      @profile_names = []
      @uploads = []
      @client = Stupeflixclient.default_client
    end

    def default_upload
      StupeflixDefaultUpload.new
    end

    def default_profile
      "iphone"
    end

    def profiles
      profileArray = @profile_names.map {|name| StupeflixProfile.new(name, uploads = @uploads) }
      StupeflixProfileSet.new(profileArray, meta = @meta, notify = @notify)
    end

    def ensure_settings
      @profile_names << default_profile if @profile_names.empty?
      @uploads << default_upload if @uploads.empty?
    end

    def run resourceName, filename
      ensure_settings
      client.sendDefinition(@username, resourceName, filename)
      client.createProfiles(@username, resourceName, profiles)
    end

    def download resourceName, profileName, fileName
      client.getProfile(@username, resourceName, profileName, fileName)
    end

    def status resourceName
      client.getStatus(@username, resourceName, nil)
    end
  end
end
